clc; clear; close all

n = 64;
m = n/8; % number of direction between 0 and pi/4
thetas = pi/4*(1/2/m:1/m:8-1/2/m);

xs = -1+1/n:2/n:1-1/n;

%--- intrisic attenuation
% att = myMap('zero',n,0.5,0.5,0.5);
att = myMap('mickey',n,0.02,12,0.2)+0.3*myMap('disk',n,1,0,0);
% att = myMap('nicebumps',n,0.1,5,0.5);%+0.3*myMap('disk',n,1,0,0);
% att = myMap('disk',n,1,0,0);

%--- scattering
coeffScat = 0.1;
% scat = coeffScat*myMap('gaussian',n,1.5/n,0.5,0.5);
% scat = coeffScat*myMap('mickey',n,0.01,16,0.2);
scat = coeffScat*myMap('sp',n,0.06,3,0.5);
% scat = coeffScat*(myMap('gaussian',n,0.3,0,0) + ...
%     myMap('gaussian',n,0.125,0.5,0.5) + ...
%     myMap('gaussian',n,0.125,-0.5,-0.5));

% cropping the coefficients to the domain
scat = scat.*myMap('disk',n,1,0,0);

nIter = 0; % number of iterations for the reconstruction scheme
nScat = 3; % number of scattering terms for the forward solver

%--- indices thIn, thOut
% indsIn = [1,1,1,1,1,1,1,1];%(1:7)*m;  
% indsOut = indsIn + (1:8)*2*m/8;
indsIn = m/2;
indsOut = indsIn + 2*m;

%--- input options
optsInput.type = 'gaussian';
optsInput.sig = 0.5/n;

%--- diffusion types
%     opts.diffType = 'linear';
%     opts.diffType = 'FPB'; opts.sigDiff = 0.0005;
    opts.diffType = 'none'; opts.sigDiff = 0;

% corrector for scattering reconstruction based 
% on unitary scattering coefficient
opts.corr = 0;

%--- options for the inverse Radon Transform    
opts.IRT.filter = 'ram-lak'; % filter for the inverse Radon Transform
opts.IRT.band = 0.9; % frequency truncation for the IRT

%--- recontruction formula for attenation
opts.rc = 'intCorr'; % 'int', 'peak', 'intCorr', 'peakCorr'

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% MAIN

% %% ============ forward solver
      attRot = rotateImages(att+2*pi*scat,thetas(1:2*m));
      
      diff = makeDiff(n,opts.diff);
      indR = ceil(2*n/3);
      indTheta = m/2;
       input = makeInput(n,m,indR,indTheta,optsInput);
      
      tic
      meas = measurements(n,m,thetas,attRot,scat,diff,input,nScat,0);
      toc
      %--- display
      rs = -1+1/n:2/n:1-1/n;
      figure;
      subplot(2,3,1); dispmat(att,'attenuation')
      subplot(2,3,2); dispmat(scat,'scattering')
      subplot(2,3,3); plot(rs,meas(:,indTheta,1)); 
      title('ballistic part at \theta=\pi/8'); xlabel('r')
      subplot(2,3,4); dispmat(meas(:,:,2)-meas(:,:,1),'single scattering'); 
      xlabel('\theta'); ylabel('r')
      subplot(2,3,5); dispmat(meas(:,:,3)-meas(:,:,2),'double scattering'); 
      xlabel('\theta'); ylabel('r')
      subplot(2,3,6); dispmat(meas(:,:,4)-meas(:,:,3),'triple scattering'); 
      xlabel('\theta'); ylabel('r')

