function [MAtt,MScat] = measForRcAttScat(n,m,thetas,att,scat,...
    nScat,diff,indIn,indOut,optsInput)

% in order to reinstall the minusBP and minusSS, see backups
% same thing for multiple indIn, indOut

MAtt = zeros(n,8*m,n);
MScat = zeros(n,n);

%--- precomputation of the rotated attenuations
attTotRots = rotateImages(att+2*pi*scat,thetas(1:2*m));

%%--- forward code
for th = 1:8*m,
    disp(['theta = ',num2str(th),' / ',num2str(8*m)]);
    tic
    if indIn ==th,
        for indR = 1:n,

            %--- forward solver with a pulse at (indR,th)
            meas = measurements(n,m,thetas,attTotRots,scat,diff, ...
                makeInput(n,m,indR,th,optsInput),nScat,[th,indOut]);

            % measurements for the attenuation
            
            MAtt(indR,th,:) = squeeze(sum(meas(:,th,:),3));
            
            % measurements for the scattering
            
            MScat(:,indR) = squeeze(sum(meas(:,indOut,:),3));
            
        end
    else %--- only measurements for attenuation
        for indR = 1:n,
            %--- forward solver with a pulse at (indR,th)
            meas = measurements(n,m,thetas,attTotRots,scat,diff, ...
                makeInput(n,m,indR,th,optsInput),nScat,th);
            
            % take the relevant part
            
            MAtt(indR,th,:) = squeeze(sum(meas(:,th,:),3));
        end
    end
    toc
end
