function res = slantResample(im,t,h)

res = zeros(size(im));

if norm(im,'fro')==0
    return
else
    [nr,nc] = size(im);
  
    shifts = (-1+1/nc:2/nc:1-1/nc)*t/2;
    N = 2*nr;
    %--- slant params
    temp1 = exp(-i*(pi/N)*(-N+1)*(0:N-1)');
    % temp2 = conj(temp1);
    
    %--- resampling params (precomputations for the FRFT of coeff -h/N
    z = exp(-i*pi*(0:N).^2*h/N);
    z = [z,z(N:-1:2)];
    Fz = fft(z).';
    factors = exp(i*pi*h/N*(0:N-1).^2).'; 
    ns = nr-1/2 - h*(nr/2-1/2);
    
    % preproc = exp(-i*(pi/N)*(-N+1)*(0:N-1).');
    % temp2.*preproc = 1
    midproc = factors.*exp(i*(pi/N)*((-N+1):2:(N-1)).'*ns);
    postproc = factors(1:nr).*exp(i*(pi/N)*(-N+1)*h*(0:(N/2-1)).');
    
    phases = -i*pi/2*((-N+1):2:(N-1))';
    
    for c=1:nc,
        % slant
        colTemp = [zeros(nr/2,1); im(:,c); zeros(nr/2,1)].* temp1;
        colTemp = fft(colTemp).*exp(shifts(c)*phases);
%         colTemp = ifft(colTemp).*temp2;
        
        % resampling
               
%         colTemp = ifft(fft(fft(colTemp).*midproc,2*N).*Fz);
        colTemp = ifft(fft(colTemp.*midproc,2*N).*Fz);
        res(:,c) = 1/N*real(postproc.*colTemp(1:nr));
    end
    
    
    
end